import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import withCheckedValue from './hoc/withCheckedValue';
var BASE_CLASS = 'sui-AtomCheckbox';
var ERROR_STATES = {
  ERROR: 'error',
  SUCCESS: 'success'
};

var getErrorStateClass = function getErrorStateClass(errorState) {
  if (errorState) return BASE_CLASS + "--" + ERROR_STATES.ERROR;
  if (errorState === false) return BASE_CLASS + "--" + ERROR_STATES.SUCCESS;
  return '';
};

var AtomCheckbox = function AtomCheckbox(_ref) {
  var _cx;

  var id = _ref.id,
      name = _ref.name,
      disabled = _ref.disabled,
      _ref$checked = _ref.checked,
      checked = _ref$checked === void 0 ? false : _ref$checked,
      _ref$onChange = _ref.onChange,
      onChangeFromProps = _ref$onChange === void 0 ? function () {} : _ref$onChange,
      errorState = _ref.errorState,
      StyledIcon = _ref.styledIcon,
      props = _objectWithoutPropertiesLoose(_ref, ["id", "name", "disabled", "checked", "onChange", "errorState", "styledIcon"]);

  var handleChange = function handleChange(ev) {
    var _ev$target = ev.target,
        checked = _ev$target.checked,
        name = _ev$target.name;
    if (!disabled) onChangeFromProps(ev, {
      name: name,
      value: checked
    });
  };

  var className = cx(BASE_CLASS, getErrorStateClass(errorState), (_cx = {}, _cx[BASE_CLASS + "--styled"] = StyledIcon, _cx['is-checked'] = StyledIcon && checked, _cx));
  return React.createElement("label", {
    className: className
  }, StyledIcon && checked ? React.createElement(StyledIcon, null) : '', React.createElement("input", Object.assign({
    type: "checkbox",
    id: id,
    name: name || id,
    disabled: disabled,
    checked: checked,
    onChange: handleChange
  }, props)));
};

AtomCheckbox.displayName = 'AtomCheckbox';
export default AtomCheckbox;
export { withCheckedValue };